
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <intuition/gadgetclass.h>
#include <intuition/imageclass.h>

int main (void)

{
struct Screen *scr;
struct Window *win;
struct IntuiMessage *imsg;
struct Gadget *gad = NULL;
struct Image *text = NULL;
static char buffer[80] = "";
static struct IntuiText itext = {1,0,JAM2,8,2,NULL,buffer,NULL};
const static ULONG putchproc[] = {0x16c04e75};	/* move.b d0,(a3)+ ; rts */
BOOL cont;

if (scr = LockPubScreen (NULL))
	{
	if (text = NewObject (NULL,"itexticlass",
			IA_Data,&itext,
			IA_FGPen,1,
			TAG_END))
		{
		gad = NewObject (NULL,"buttongclass",
			GA_Image,text,
			GA_Left,scr->WBorLeft,
			GA_RelBottom,-scr->RastPort.TxHeight - 2,
			GA_RelWidth,-scr->WBorLeft - 18,
			GA_Height,scr->RastPort.TxHeight + 2,
			GA_BottomBorder,TRUE,
			TAG_END);
		}

	if (gad)
		{
		if (win = OpenWindowTags (NULL,
				WA_Title,"Move the mouse !",
				WA_PubScreen,scr,
				WA_Left,(scr->Width - 200) / 2,
				WA_Top,(scr->Height - 100) / 2,
				WA_Width,200,
				WA_Height,100,
				WA_Flags,WFLG_CLOSEGADGET | WFLG_DRAGBAR | WFLG_DEPTHGADGET | WFLG_SIZEGADGET | WFLG_REPORTMOUSE | WFLG_ACTIVATE | WFLG_NOCAREREFRESH,
				WA_IDCMP,IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | IDCMP_MOUSEMOVE,
				WA_MaxWidth,scr->Width,
				WA_MaxHeight,scr->Height,
				WA_Gadgets,gad,
				TAG_END))
			{

			cont = TRUE;
			do	{
				if (Wait ((1L << win->UserPort->mp_SigBit) | SIGBREAKF_CTRL_C) & SIGBREAKF_CTRL_C)
					cont = FALSE;

				while (imsg = (struct IntuiMessage *) GetMsg (win->UserPort))
					{
					switch (imsg->Class)
						{
					case IDCMP_MOUSEMOVE:
						RawDoFmt ("Mouse: X = %d; Y = %d",&imsg->MouseX,(void *)putchproc,buffer);
						RefreshWindowFrame (win);
						break;
					case IDCMP_VANILLAKEY:
						if (imsg->Code == 0x1b) /* Esc */
							cont = FALSE;
						break;
					case IDCMP_CLOSEWINDOW:
						cont = FALSE;
						break;
						}
					ReplyMsg ((struct Message *) imsg);
					}
				}
			while (cont);

			CloseWindow (win);
			}

		DisposeObject (gad);
		}

	if (text)
		DisposeObject (text);

	UnlockPubScreen (NULL,scr);
	}

return (0);
}

